FunctionCall (Rhino)
Date: 2015-04-27

org.mozilla.javascript.ast

## Class FunctionCall

- java.lang.Object
- - org.mozilla.javascript.Node
  - - org.mozilla.javascript.ast.AstNode
    - - org.mozilla.javascript.ast.FunctionCall

- All Implemented Interfaces:
    java.lang.Comparable<AstNode>, java.lang.Iterable<Node>
  Direct Known Subclasses:
    NewExpression

      public class FunctionCall
      extends AstNode

  AST node for a function call. Node type is `Token.CALL`.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode

      `AstNode.DebugPrintVisitor, AstNode.PositionComparator`

    - ### Nested classes/interfaces inherited from class org.mozilla.javascript.Node

      `Node.NodeIterator`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.List<AstNode>` | `arguments`
    `protected int` | `lp`
    `protected static java.util.List<AstNode>` | `NO_ARGS`
    `protected int` | `rp`
    `protected AstNode` | `target`

    - ### Fields inherited from class org.mozilla.javascript.ast.AstNode

      `length, parent, position`

    - ### Fields inherited from class org.mozilla.javascript.Node

      `ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FunctionCall()`
    `FunctionCall(int pos)`
    `FunctionCall(int pos, int len)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addArgument(AstNode arg)` Adds an argument to the list, and sets its parent to this node.
    `java.util.List<AstNode>` | `getArguments()` Returns function argument list
    `int` | `getLp()` Returns left paren position, -1 if missing
    `int` | `getRp()` Returns right paren position, -1 if missing
    `AstNode` | `getTarget()` Returns node evaluating to the function to call
    `void` | `setArguments(java.util.List<AstNode> arguments)` Sets function argument list
    `void` | `setLp(int lp)` Sets left paren position
    `void` | `setParens(int lp, int rp)` Sets both paren positions
    `void` | `setRp(int rp)` Sets right paren position
    `void` | `setTarget(AstNode target)` Sets node evaluating to the function to call, and sets its parent to this node.
    `java.lang.String` | `toSource(int depth)` Emits source code for this node.
    `void` | `visit(NodeVisitor v)` Visits this node, the target object, and the arguments.

    - ### Methods inherited from class org.mozilla.javascript.ast.AstNode

      `addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

    - ### Methods inherited from class org.mozilla.javascript.Node

      `addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getJsDocNode, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, resetTargets, setDouble, setJsDocNode, setLineno, setScope, setString, setType, toString, toStringTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### NO_ARGS

          protected static final java.util.List<AstNode> NO_ARGS

    - #### target

          protected AstNode target

    - #### arguments

          protected java.util.List<AstNode> arguments

    - #### lp

          protected int lp

    - #### rp

          protected int rp

  - ### Constructor Detail

    - #### FunctionCall

          public FunctionCall()

    - #### FunctionCall

          public FunctionCall(int pos)

    - #### FunctionCall

          public FunctionCall(int pos,
                      int len)

  - ### Method Detail

    - #### getTarget

          public AstNode getTarget()

      Returns node evaluating to the function to call

    - #### setTarget

          public void setTarget(AstNode target)

      Sets node evaluating to the function to call, and sets its parent to this node.
      Parameters:
        `target` - node evaluating to the function to call.
      Throws:
        `IllegalArgumentException}` - if target is `null`

    - #### getArguments

          public java.util.List<AstNode> getArguments()

      Returns function argument list
      Returns:
        function argument list, or an empty immutable list if there are no arguments.

    - #### setArguments

          public void setArguments(java.util.List<AstNode> arguments)

      Sets function argument list
      Parameters:
        `arguments` - function argument list. Can be `null`, in which case any existing args are removed.

    - #### addArgument

          public void addArgument(AstNode arg)

      Adds an argument to the list, and sets its parent to this node.
      Parameters:
        `arg` - the argument node to add to the list
      Throws:
        `IllegalArgumentException}` - if arg is `null`

    - #### getLp

          public int getLp()

      Returns left paren position, -1 if missing

    - #### setLp

          public void setLp(int lp)

      Sets left paren position
      Parameters:
        `lp` - left paren position

    - #### getRp

          public int getRp()

      Returns right paren position, -1 if missing

    - #### setRp

          public void setRp(int rp)

      Sets right paren position

    - #### setParens

          public void setParens(int lp,
                       int rp)

      Sets both paren positions

    - #### toSource

          public java.lang.String toSource(int depth)

      Description copied from class: `AstNode`
      Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

      Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

      Specified by:
        `toSource` in class `AstNode`
      Parameters:
        `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

    - #### visit

          public void visit(NodeVisitor v)

      Visits this node, the target object, and the arguments.
      Specified by:
        `visit` in class `AstNode`
      Parameters:
        `v` - the object to call with this node and its children